# frozen_string_literal: true

# checker Api::Dmo::HermesController avant d'ajouter des méthodes
class Hermes::Api::Dmo::ThresholdsController < Hermes::Api::Dmo::ApplicationController
  class << self
    def mutate_params
      {
        type: {type: 'String'},
        codes: {type: 'Array'},
        thresholds_map: {type: 'Hash'},
      }
    end 

    def acceptable_params
      {
        housing_offer_ids: {type: 'Array'},
      }.merge(self.mutate_params).merge(super)
    end 

    def valid_operators
      %w[$in $nin $ne $gt $gte $lt $lte $regex]
    end

    def regex_params
      {
        type: {type: 'String'},
        codes: {type: 'Array'},
      }
    end 
  end


  def index
    acceptable_params *self.class.acceptable_params.keys
    regex_params *self.class.regex_params.keys
    valid_operators *self.class.valid_operators
    super
  end
end
