# frozen_string_literal: true

::Api::AuthController.class_eval do

  def token
    password = params[:password]
    username = params[:username]

    if !params[:auth].blank?
      params[:auth] = params[:auth].symbolize_keys
      password = params[:auth][:password]
      username = params[:auth][:username]
    end
    if user = User.find_first_by_auth_conditions({:username => username})
      if user.trusted? && user.valid_password?(password)
        if params.has_key?(:grant_type)
          token = user.generate_jwt
          render :status => 200,
               :json => { :success => true,
                          :info => t(:registered),
                          :email => user.email,
                          :login => user.login,
                          :access_token => token }
        else
          render :status => 200,
                :json => { :success => true,
                           :info => t(:registered),
                           :email => user.email,
                           :login => user.login,
                           :user_token => user.authentication_token }
        end

      else
        Rails.logger.debug "pass"
        render :status => :unauthorized,
               :json => { :success => false,
                          :info => t(:login_error, username: username) }
      end
    else
        Rails.logger.debug "user not found"
      render :status => :unauthorized,
             :json => { :success => false,
                        :info => t(:login_error, username: username) }
    end
  end

end
